import { select } from 'd3';

export const viz = (
  container,
  { state, setState }
) => {
  const svg = select(container)
    .selectAll('svg')
    .data([null])
    .join('svg')
    .attr('width', window.innerWidth)
    .attr('height', window.innerHeight);

  let fillColor =
    'rgba(' +
    Math.round(Math.random() * 255) +
    ', ' +
    Math.round(Math.random() * 255) +
    ', ' +
    Math.round(Math.random() * 255) +
    ', ' +
    '0.7' +
    ')';

  svg.on('mousemove', (event) => {
    setState(() => ({
      x: event.x,
      y: event.y,
      fill: state.fill,
    }));
  });
  svg.on('click', (event) => {
    setState(() => ({
      x: event.x,
      y: event.y,
      fill: fillColor,
    }));

    svg
      .selectAll('text')
      .transition()
      .duration(200)
      .text(fillColor)
      .attr('font-size', '30px');
  });

  const { x, y, fill } = state;

  svg
    .selectAll('text')
    .data([null])
    .join('text')
    .attr('x', x)
    .attr('y', y)
    .attr('font-size', '25px')
    .attr('fill', fill)
    .text('Click to change the color!');
};
